/****************************************************************************
**
** Copyright (C) 2012 Nokia Corporation and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/
**
** This file is part of the QtCore module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:LGPL$
** GNU Lesser General Public License Usage
** This file may be used under the terms of the GNU Lesser General Public
** License version 2.1 as published by the Free Software Foundation and
** appearing in the file LICENSE.LGPL included in the packaging of this
** file. Please review the following information to ensure the GNU Lesser
** General Public License version 2.1 requirements will be met:
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU General
** Public License version 3.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of this
** file. Please review the following information to ensure the GNU General
** Public License version 3.0 requirements will be met:
** http://www.gnu.org/copyleft/gpl.html.
**
** Other Usage
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Nokia.
**
**
**
**
**
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef QTCONCURRENT_GLOBAL_H
#define QTCONCURRENT_GLOBAL_H

#include <QtCore/qglobal.h>

#ifdef QT_NO_CONCURRENT
#  define QT_NO_QFUTURE
#endif

#if defined(Q_OS_WIN) && !defined(QT_NODLL)
#  if defined(QT_MAKEDLL)
#    if defined(QT_BUILD_CONCURRENT_LIB)
#      define Q_CONCURRENT_EXPORT Q_DECL_EXPORT
#    else
#      define Q_CONCURRENT_EXPORT Q_DECL_IMPORT
#    endif
#  elif defined(QT_DLL)
#    define Q_CONCURRENT_EXPORT Q_DECL_IMPORT
#  endif
#endif

#if !defined(Q_CONCURRENT_EXPORT)
#  if defined(QT_SHARED)
#    define Q_CONCURRENT_EXPORT Q_DECL_EXPORT
#  else
#    define Q_CONCURRENT_EXPORT
#  endif
#endif

#endif // include guard
